#define WIN32_LEAN_AND_MEAN  // Exclude rarely-used stuff from Windows headers
#define MT4_EXPFUNC __declspec(dllexport)
#define _USE_INLINING
#define TRACE

#include <assert.h>
#include <locale.h>
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <atlstr.h>


#include <shlwapi.h>
#include <shellapi.h>
#include <commctrl.h>
#pragma comment(lib, "shell32.lib")
#pragma comment(lib, "user32.lib")

//#include <advapi.h>

#undef EOF

#import "C:\Program Files\Common Files\System\ado\msado27.tlb"  //rename("EOF","ADOEOF") rename("BOF","ADOBOF")

//#import "C:\Program Files\Common Files\System\ado\msado27.tlb" rename( "EOF", "EndOfFile" ) inject_statement("typedef BSTR DataMember;")
//#pragma comment(lib, "ADVAPI32.lib")

using namespace ADODB;

#include "MQLAdoDB.h"

//USES_CONVENVERSION;
wchar_t WideNull[1];
wchar_t buffer[256];


// just for compatibility
BOOL APIENTRY DllMain(HANDLE hModule,DWORD ul_reason_for_call,LPVOID lpReserved)
{
	switch(ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH: WideNull[0] = 0; ConnectionsInit(); CursorsInit(); break;
	case DLL_THREAD_ATTACH: break;
	case DLL_THREAD_DETACH: break;
	case DLL_PROCESS_DETACH: ConnectionsDeinit(); CursorsDeinit(); break;
   }
   return(TRUE);
}

MT4_EXPFUNC wchar_t* __stdcall cAdoDBVersion()
{
	return(L"MQLAdoDB v3.1 Copyright  2015, FxCodex Laboratory");
}

MT4_EXPFUNC int __stdcall cGetAdoDBErrorNumber(int pConnection)
{
	if ((pConnection<0) || (pConnection>=MAX_CONNECTIONS)) {return (AdoDBErrorNumber);}
	if (Connections[pConnection].Id == -1) {return (AdoDBErrorNumber);}
	return (Connections[pConnection].AdoDBErrorNumber);
}

MT4_EXPFUNC wchar_t* __stdcall cGetAdoDBErrorDescription(int pConnection)
{
	if ((pConnection<0) || (pConnection>=MAX_CONNECTIONS)) {return (AdoDBErrorDescription);}
	if (Connections[pConnection].Id == -1) {return (AdoDBErrorDescription);}
	return (Connections[pConnection].AdoDBErrorDescription);
}

MT4_EXPFUNC int __stdcall cGetCursorErrorNumber(int pCursor)
{
	if ((pCursor<0) || (pCursor>=MAX_CURSORS)) {return (CursorErrorNumber);}
	if (Cursors[pCursor].Id == -1) {return (CursorErrorNumber);}
	return (Cursors[pCursor].CursorErrorNumber);
}

MT4_EXPFUNC wchar_t* __stdcall cGetCursorErrorDescription(int pCursor)
{
	if ((pCursor<0) || (pCursor>=MAX_CURSORS)) {return (CursorErrorDescription);}
	if (Cursors[pCursor].Id == -1) {return (CursorErrorDescription);}
	return (Cursors[pCursor].CursorErrorDescription);
}

inline void TESTHR(HRESULT x) { if FAILED(x) _com_issue_error(x); };

// return connection id
MT4_EXPFUNC int __stdcall cAdoDBConnect(wchar_t* pConnectionString)
{
 //  
 SCOPE_LOCK_MUTEX(g_mutex.get());

 //   
 if (AdoDBErrorNumber == -1) return(-1);

 ClearErrors(-1);
 int cnn = GetNewConnectionId();
 HRESULT hr = S_OK;
 Connections[cnn].Db = NULL;
 Connections[cnn].Id = cnn;
 
 try {
	  ::CoInitialize(NULL);
      // Open connection
      hr = Connections[cnn].Db.CreateInstance(__uuidof(Connection));
      Connections[cnn].Db->Open (_bstr_t(pConnectionString), "", "", adConnectUnspecified);
	  //Connections[cnn].Id = cnn;
	  if( FAILED( hr ) )
         {
         }
     }
 catch (_com_error) 
     {
	  GenerateGlobalError(cnn);
      Connections[cnn].Id = -1;
	  Connections[cnn].Db = NULL;
      cnn = -1;
     }

 return (cnn);
}

MT4_EXPFUNC void __stdcall cAdoDBDisconnect(int pConnection)
{
	ClearErrors(pConnection);
	if ((pConnection<0) || (pConnection>=MAX_CONNECTIONS))
	   {
        AdoDBErrorNumber = -2;
		swprintf(AdoDBErrorDescription, 32, L"No connection to the database.\x00");
		return;
	   }
	if (Connections[pConnection].Id == -1)
	   {
        AdoDBErrorNumber = -2;
		swprintf(AdoDBErrorDescription, 32, L"No connection to the database.\x00");
		return;
	   }

	if (Connections[pConnection].Db) 
		if (Connections[pConnection].Db->State == adStateOpen) 
		   {
		    Connections[pConnection].Db->Close();
            DeleteConnection(pConnection);
	       }
}

MT4_EXPFUNC bool __stdcall cAdoDBExecute(int pConnection, wchar_t* pQuery)
{
	ClearErrors(pConnection);
	bool Result = true;

	if ((pConnection<0) || (pConnection>=MAX_CONNECTIONS))
	   {
        AdoDBErrorNumber = -2;
		swprintf(AdoDBErrorDescription, 32, L"No connection to the database.\x00");
		return (false);
	   }
	if (Connections[pConnection].Id == -1)
	   {
        AdoDBErrorNumber = -2;
		swprintf(AdoDBErrorDescription, 32, L"No connection to the database.\x00");
		return (false);
	   }

	try {
	  Connections[pConnection].Db->Errors->Clear();
	  Connections[pConnection].Db->Execute(_bstr_t(pQuery), NULL, adExecuteNoRecords);
	}
    catch (_com_error) {
		Result = false;
        GenerateGlobalError(pConnection);
    }

	return (Result);
}

// create cursor for data fetching
// return value is CURSOR IDENTIFIER when succeded,
// othervise return value = -1
MT4_EXPFUNC int __stdcall cAdoDBCursorOpen(int pConnection, wchar_t* pQuery)
{
 SCOPE_LOCK_MUTEX(g_mutex.get());

	ClearCursorErrors(-1);
	ClearErrors(pConnection);
	int Result = -1;
	int CurID;
	if ((pConnection<0) || (pConnection>=MAX_CONNECTIONS))
	   {
		AdoDBErrorNumber = -2;
		swprintf(AdoDBErrorDescription, 32, L"No connection to the database.\x00");
		return (-1);
	   }
	if (Connections[pConnection].Id == -1)
	   {
		AdoDBErrorNumber = -2;
		swprintf(AdoDBErrorDescription, 32, L"No connection to the database.\x00");
		return (-1);
	   }
	CurID = GetNewCursorId();
	Cursors[CurID].Id = CurID;
	setlocale(LC_ALL, "Russian");

    try {
		Connections[pConnection].Db->Errors->Clear();
		TESTHR(Cursors[CurID].RS.CreateInstance(__uuidof(Recordset)));
		Cursors[CurID].RS->Open(_bstr_t(pQuery), _variant_t((IDispatch *)Connections[pConnection].Db, true), adOpenStatic, adLockReadOnly, NULL);
		Cursors[CurID].ConnectionID = pConnection;
		Result = CurID;
	}
	catch (_com_error &x) {
		MessageBox(0, x.ErrorMessage(), x.Description(), MB_OK);
		GenerateGlobalError(pConnection);
		Result = -1;
		Cursors[CurID].Id = -1;
		Cursors[CurID].ConnectionID = -1;
   }

 return (Result);
}

// closes opened cursor and release memory
MT4_EXPFUNC void __stdcall cAdoDBCursorClose(int pCursorID)
{
	SCOPE_LOCK_MUTEX(g_mutex.get());

	ClearCursorErrors(pCursorID);

	if ((pCursorID<0) || (pCursorID>=MAX_CURSORS))
	   {
        CursorErrorNumber = -5;
        swprintf(CursorErrorDescription, 32, L"Wrong CURSOR identifier.\x00");
		return;
	   }
	if (Cursors[pCursorID].Id==-1)
	   {
        CursorErrorNumber = -5;
        swprintf(CursorErrorDescription, 32, L"Wrong CURSOR identifier.\x00");
		return;
	   }
	if (Cursors[pCursorID].RS)
      if (Cursors[pCursorID].RS->State == adStateOpen)
	    {
         Cursors[pCursorID].RS->Close();
	     DeleteCursor(pCursorID);
	    }
}


// return count of rows was selected into cursor
MT4_EXPFUNC int __stdcall cAdoDBCursorRows(int pCursorID)
{
	int result;
	ClearCursorErrors(pCursorID);
	if ((pCursorID<0) || (pCursorID>=MAX_CURSORS))
	   {
        CursorErrorNumber = -5;
        swprintf(CursorErrorDescription, 32, L"Wrong CURSOR identifier.\x00");
		return 0;
	   }
	if (Cursors[pCursorID].Id==-1)
	   {
        CursorErrorNumber = -5;
        swprintf(CursorErrorDescription, 32, L"Wrong CURSOR identifier.\x00");
		return 0;
	   }

	try {
		//Cursors[pCursorID].RS->GetRecordCount();
		result = (int)Cursors[pCursorID].RS->GetRecordCount();
	}
    catch (_com_error &e) {
		result = 0;
		Cursors[pCursorID].CursorErrorNumber = e.Error();
        swprintf(Cursors[pCursorID].CursorErrorDescription, 1024, L"%s",e.ErrorMessage());
    }
	return (result);
}

// fetch 1 row from record set into cursor's buffer
MT4_EXPFUNC bool __stdcall cAdoDBCursorFetchRow(int pCursorID)
{
	bool Result = false;
	ClearCursorErrors(pCursorID);

	if ((pCursorID<0) || (pCursorID>=MAX_CURSORS))
	   {
        CursorErrorNumber = -5;
        swprintf(CursorErrorDescription, 32, L"Wrong CURSOR identifier.\x00");
		return (Result);
	   }
	if (Cursors[pCursorID].Id==-1)
	   {
        CursorErrorNumber = -5;
        swprintf(CursorErrorDescription, 32, L"Wrong CURSOR identifier.\x00");
		return (Result);
	   }

	try {
		Result = true;
		//Connections[Cursors[pCursorID].ConnectionID].Db->Errors->Clear();
        if (Cursors[pCursorID].FirstRow)
           {
            Cursors[pCursorID].FirstRow = false;
            Cursors[pCursorID].RS->MoveFirst();
			Cursors[pCursorID].Fields = Cursors[pCursorID].RS->Fields->Count;
           }
        else
           {
            Cursors[pCursorID].RS->MoveNext();
			if (Cursors[pCursorID].RS->EOF == VARIANT_TRUE)
			   {
				Cursors[pCursorID].CursorErrorNumber = 6;
				swprintf(Cursors[pCursorID].CursorErrorDescription, 1024, L"Last record reached.\x00");
				Result = false;
			   }
           }
	}
    catch (_com_error) {
		Result = false;
		GenerateCursorError(pCursorID);
    }
	return (Result);
}

// return string representation of field's value
// should be called after MySqlCursorFetchRow()
// pCursorID - CURSOR IDENTIFIER
// pField    - number of field from SELECT list (started from 0) - 0,1,2 e.t.c.
MT4_EXPFUNC wchar_t* __stdcall cAdoDBGetRowField(int pCursorID, int pField)
{
	SCOPE_LOCK_MUTEX(g_mutex.get());
	ClearCursorErrors(pCursorID);
	if ((pCursorID<0) || (pCursorID>=MAX_CURSORS))
	   {
        CursorErrorNumber = -5;
        swprintf(CursorErrorDescription, 32, L"Wrong CURSOR identifier.\x00");
        return (WideNull);
	   }
	if (Cursors[pCursorID].Id==-1)
	   {
        CursorErrorNumber = -5;
        swprintf(CursorErrorDescription, 32, L"Wrong CURSOR identifier.\x00");
        Cursors[pCursorID].Value[0] = 0;
        return (WideNull);
	   }

	if ((pField<0) || (pField>=Cursors[pCursorID].Fields))
	   {
        CursorErrorNumber = -4;
        swprintf(CursorErrorDescription, 32, L"Wrong number of field.\x00");
        return (WideNull);
	   }

	_variant_t FieldValue;

	FieldValue = Cursors[pCursorID].RS->GetFields()->GetItem(long(pField))->Value;

    switch (FieldValue.vt) {
         case (VT_DATE):
			  SYSTEMTIME st;
			  VariantTimeToSystemTime(FieldValue.date, &st);
			  swprintf(Cursors[pCursorID].Value, 1024, L"%04d.%02d.%02d %02d:%02d:%02d", st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond);
			  return(Cursors[pCursorID].Value);
			  break;
         case (VT_BOOL):
            if (FieldValue.boolVal)
			   swprintf(Cursors[pCursorID].Value, 2, L"1\x00");
            else
			   swprintf(Cursors[pCursorID].Value, 2, L"0\x00");
			return(Cursors[pCursorID].Value);
            break;
         case (VT_BSTR):
			  swprintf(Cursors[pCursorID].Value, 1024, L"%s", (LPCSTR)(FieldValue.bstrVal));
			  return (Cursors[pCursorID].Value);
              break;
         case (VT_I4):
              swprintf(Cursors[pCursorID].Value, 1024, L"%d", FieldValue.intVal);
			  return(Cursors[pCursorID].Value);
              break;
         case (VT_I2):
              swprintf(Cursors[pCursorID].Value, 1024, L"%d", FieldValue.intVal);
			  return(Cursors[pCursorID].Value);
         case (VT_CY):
			  swprintf(Cursors[pCursorID].Value, 1024, L"%f", (double)FieldValue);
			  return(Cursors[pCursorID].Value);
		 case (VT_DECIMAL):
			  swprintf(Cursors[pCursorID].Value, 1024, L"%f", (double)FieldValue);
			  return(Cursors[pCursorID].Value);
			  break;
		 case (VT_R8):
			  swprintf(Cursors[pCursorID].Value, 1024, L"%f", (double)FieldValue);
			  return(Cursors[pCursorID].Value);
			  break;
		 case (VT_R4):
			  swprintf(Cursors[pCursorID].Value, 1024, L"%f", (double)FieldValue);
			  return(Cursors[pCursorID].Value);
			  break;
         case (VT_EMPTY):
              return (WideNull);
              break;
         case (VT_NULL):
              return (WideNull);
              break;
         default:
			  swprintf(Cursors[pCursorID].Value, 1024, L"Unknown type: %d", FieldValue.vt);
			  //MessageBoxW(0, Cursors[pCursorID].Value,L"Error!",MB_OK);
              return (WideNull);
            break;
         }
     
  return (WideNull);
}

MT4_EXPFUNC int __stdcall cAdoDBFirstConnection()
{
 for (int i=0; i<MAX_CONNECTIONS; i++)
     {
	  if (Connections[i].Id != -1) return(i);
	 }
 return(-1);
}

// Reads and returns the key value from standard INI-file
// [SECTION]
// Key = Value
// pFileName - name of file
// pSection  - name of section '[SECTION]'
// pKey      - name of key 'Key ='
// @return   - string value of key 'Value'
MT4_EXPFUNC wchar_t* __stdcall ReadIni (wchar_t* pFileName, wchar_t* pSection, wchar_t* pKey)
{
 SCOPE_LOCK_MUTEX(g_mutex.get());
 int x;
 buffer[0] = 0;
 x = GetPrivateProfileStringW(pSection, pKey, L"", buffer, 255, pFileName);
 buffer[x] = 0;

 return (buffer);
}

MT4_EXPFUNC wchar_t* __stdcall ReadHKCUString (wchar_t* pPath, wchar_t* pKey)
{
 SCOPE_LOCK_MUTEX(g_mutex.get());
 HKEY rKey = NULL;
 DWORD   lSize = 255;
 buffer[0] = 0;
 RegOpenKeyExW(HKEY_CURRENT_USER, pPath, NULL, KEY_QUERY_VALUE, &rKey);
 if (rKey != NULL)
 {
     RegQueryValueExW(rKey, pKey, NULL, NULL, (LPBYTE)&buffer, &lSize);
	 buffer[lSize] = 0;
	 RegCloseKey(rKey);
	 return (buffer);
 }
 
 return (L"");
}

